## lace 1.4

=== Makefile ===
all: test doc

MODULES := lace lace.lex lace.compiler lace.builtin lace.engine lace.error
LUA_VER := 5.1

PREFIX ?= /usr/local

INST_BASE := $(PREFIX)
INST_ROOT := $(DESTDIR)$(INST_BASE)/share/lua/$(LUA_VER)

MOD_FILES := $(patsubst %,%.lua,$(subst .,/,$(MODULES)))

install:
	mkdir -p $(INST_ROOT)/lace
	for MOD in $(sort $(MOD_FILES)); do \
		cp lib/$${MOD} $(INST_ROOT)/$${MOD}; \
	done

LUA := LUA_PATH="$(shell pwd)/lib/?.lua;$(shell pwd)/extras/luacov/src/?.lua;;" lua$(LUA_VER)

clean:
	$(RM) luacov.report.out luacov.stats.out
	$(RM) -r html

distclean: clean
	find . -name "*~" -delete

.PHONY: example
example:
	$(LUA) example/lace-example.lua

.PHONY: test
test:
	@$(RM) luacov.stats.out
	@ERR=0; \
	for MOD in $(sort $(MODULES)); do \
		echo -n "$${MOD}: "; \
		$(LUA) test/test-$${MOD}.lua; \
		test "x$$?" = "x0" || ERR=1; \
	done; \
	$(LUA) extras/luacov/src/bin/luacov -X luacov. -X test. $(MODULES); \
	exit $$ERR

.PHONY: interactive
interactive:
	$(LUA) -e'lace=require"lace"' -i

doc:
	@echo "Running LDoc"
	@ldoc .

## lace 0.1.0

=== debian/changelog ===
lace (0.1.0-0ubuntu1) resolute; urgency=medium

  * Initial upload (LP: #2133779)

 -- Julian Andres Klode <juliank@ubuntu.com>  Tue, 03 Mar 2026 08:58:13 +0100

=== debian/control ===
Source: lace
Section: utils
Priority: optional
Build-Depends: debhelper-compat (= 12),
               dh-cargo (>= 24),
               dh-sequence-bash-completion,
               cargo-1.91:native,
               cargo:native,
               lld-20:native,
               rust-1.91-src:native,
               rustc-1.91:native,
               rustc:native,
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Standards-Version: 4.6.2
Homepage: https://github.com/canonical/lace
XS-Vendored-Sources-Rust: aho-corasick@1.1.4, anstream@0.6.21, anstyle-parse@0.2.7, anstyle-query@1.1.5, anstyle@1.0.13, bit_field@0.10.3, bitflags@2.10.0, cfg-if@1.0.4, clap@4.5.57, clap_builder@4.5.57, clap_derive@4.5.55, clap_lex@0.7.6, clap_mangen@0.2.31, colorchoice@1.0.4, crc32fast@1.5.0, equivalent@1.0.2, errno@0.3.14, fdt@0.1.5, flate2@1.1.5, hashbrown@0.16.1, heck@0.5.0, indexmap@2.12.1, is_terminal_polyfill@1.70.2, itoa@1.0.15, libc@0.2.177, libz-rs-sys@0.5.4, linux-raw-sys@0.11.0, lock_api@0.4.14, log@0.4.29, memchr@2.7.6, proc-macro2@1.0.106, ptr_meta@0.3.1, ptr_meta_derive@0.3.1, quote@1.0.44, regex-automata@0.4.13, regex-syntax@0.8.8, regex@1.12.3, roff@0.2.2, rustix@1.1.2, scopeguard@1.2.0, serde@1.0.228, serde_core@1.0.228, serde_derive@1.0.228, serde_json@1.0.149, spin@0.10.0, strsim@0.11.1, syn@2.0.114, terminal_size@0.4.3, typed-path@0.12.1, ucs2@0.3.3, uefi-macros@0.19.0, uefi-raw@0.13.0, uefi@0.36.1, uguid@2.2.1, unicode-ident@1.0.22, utf8parse@0.2.2, zerocopy-derive@0.8.39, zerocopy@0.8.39, zip@7.4.0, zlib-rs@0.5.4, zmij@1.0.10
Rules-Requires-Root: no

Package: lace-stubble
Architecture: any
Multi-Arch: foreign
Depends: ${cargo:Depends},
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: ${cargo:Recommends},
Suggests: ${cargo:Suggests},
Conflicts: stubble,
Replaces: stubble,
Provides: stubble (= 5),
          ${cargo:Provides},
Built-Using: ${cargo:Built-Using},
XB-X-Cargo-Built-Using: ${cargo:X-Cargo-Built-Using}
Description: UEFI kernel stub with device-tree loading capability
 Small Linux kernel EFI boot stub bundling device trees, a CHID database
 and the kernel. The stub finds a matching device tree based on CHIDs
 generated from SMBIOS and loads it before executing the embedded kernel.
 .
 Also contains some matching user space utilities like pewrap to build
 stubble images or collect-hwids to collect hwids for stubble.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/rustc/architecture.mk

DEB_UEFI_RUST_TYPE = $(shell echo $(DEB_HOST_RUST_TYPE) | sed s#unknown-.*#unknown-uefi#)

export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
export DEB_HOST_RUST_TYPE DEB_HOST_GNU_TYPE
export CARGO_PROFILE_RELEASE_DEBUG=true
VERSION := $(shell dpkg-parsechangelog -S Version|sed -e "s|.*~\(.*\)-.*|\1|g")
UPSTREAM_VERSION := $(shell dpkg-parsechangelog -S Version|cut -d- -f1)

# Vendoring setup
# FIXME: The upstream Makefile we use doesn't work with the cargo wrapper,
# as it assumes no cross-compilation and hence files appearing in target/release
# rather than the architecture-specific target directory.
#export CARGO = /usr/share/cargo/bin/cargo
export CARGO_VENDOR_DIR = rust-vendor
export CARGO_HOME = $(CURDIR)/debian/cargo_home
export DEB_CARGO_CRATE = lace_$(VERSION)
export CARGO = /usr/share/cargo/bin/cargo

VENDOR_TARBALL = lace_$(UPSTREAM_VERSION).orig-$(CARGO_VENDOR_DIR).tar.xz

%:
	dh $@ --buildsystem cargo

run-decopy:
	rm -f debian/copyright.in.d/* debian/copyright
	for crate in rust-vendor/*/; do decopy $$crate  -j 8 --no-split-on-license -o debian/copyright.in.d/$$(basename $$crate) --mode partial -X '*LICENSE*' -X 'COPYING' ; done

debian/copyright: debian/copyright.header debian/copyright.d/* debian/rules
	( cat debian/copyright.header; echo; \
	  for crate in $(shell ls -1 debian/copyright.d | sort); do \
	  	grep-dctrl -FFiles "" debian/copyright.d/$$crate || true; \
	  done; \
	  for crate in $(shell ls -1 debian/copyright.d | sort); do \
	  	grep-dctrl --not -FFiles "" debian/copyright.d/$$crate || true; \
	  done | sort-dctrl -kLicense ) > debian/copyright.new
	cme check dpkg-copyright
	mv debian/copyright.new debian/copyright

vendor-tarball-quick-check:
	if [ -e ../$(VENDOR_TARBALL) ]; then echo "../$(VENDOR_TARBALL) already exists, bailing!"; exit 1; fi

vendor-deps-cargo:
	rm -rf $(CARGO_VENDOR_DIR)
	# Deliberately don't use the wrapper, as it expects the configure step
	# to have occurred already.
	# If you have to modify the path here, don't forget to change the README.source doc
	# as well.
	env -i cargo-vendor-filterer --all-features  --platform '*-*-linux-gnu' --platform '*-*-unknown-*' $(CARGO_VENDOR_DIR)

vendor-deps: vendor-deps-cargo
	rm -r \
		$(CARGO_VENDOR_DIR)/*/tests
	# Remove the checksum files to allow us to patch the crates to remove extraneous dependencies
	for crate in $(CARGO_VENDOR_DIR)/*; do \
		sed -i 's/^{"files":.*"package":"\([a-z0-9]\+\)"}$$/{"files":{},"package":"\1"}/' $$crate/.cargo-checksum.json; \
		done
	# Cleanup temp files
	rm -rf $(CARGO_HOME)

vendor-tarball: vendor-tarball-quick-check vendor-deps
	tar --sort=name --mtime=@0 --owner=0 --group=0 --numeric-owner --pax-option=exthdr.name=%d/PaxHeaders/%f,delete=atime,delete=ctime -caf ../$(VENDOR_TARBALL) $(CARGO_VENDOR_DIR)

override_dh_auto_configure:
	# We need to use a merged vendor directory to get the vendored dependencies from the rust standard library.
	rm -rf debian/merged-vendor
	mkdir debian/merged-vendor
	ln -sf $(CURDIR)/rust-vendor/* debian/merged-vendor
	ln -sf /usr/src/rustc-1.91.1/vendor/* debian/merged-vendor
	$(CARGO) prepare-debian debian/merged-vendor
	# Configure a cargo home for metal builds. This does not support most rustflags set by debcargo,
	# particularly the linker flag throws it up, so delete them.
	rm -rf $(CARGO_HOME).metal
	cp -a $(CARGO_HOME) $(CARGO_HOME).metal
	sed /rustflags/d -i $(CARGO_HOME).metal/config.toml
	# Configure cargo to build the core and alloc libraries itself as bare metal targets don't have
	# pre-built libraries
	echo '[unstable]' >>  $(CARGO_HOME).metal/config.toml
	echo 'build-std = ["core", "alloc"]' >>  $(CARGO_HOME).metal/config.toml
	echo 'build-std-features = ["compiler-builtins-mem"]' >>  $(CARGO_HOME).metal/config.toml
	/usr/share/cargo/bin/dh-cargo-vendored-sources

override_dh_auto_test:
	# dh_auto_test does not work due to feature unification across uefi and std targets
	./scripts/cargo_ci.py test --verbose --workspace

override_dh_auto_install:
	$(CARGO) build --verbose -p pewrap -p collect-hwids --release
	cargo run -p xtask -- mangen
	# FIXME(juliank): This only works for cargo-1.91
	RUSTC_BOOTSTRAP=1 CARGO_HOME=$(CARGO_HOME).metal cargo-1.91 -v build -p lace-stubble --target $(DEB_UEFI_RUST_TYPE) --release

	dh_install -p lace-stubble target/$(DEB_UEFI_RUST_TYPE)/release/lace-stubble.efi usr/lib/stubble/
	dh_install -p lace-stubble target/$(DEB_HOST_RUST_TYPE)/release/pewrap usr/bin/
	dh_install -p lace-stubble target/$(DEB_HOST_RUST_TYPE)/release/collect-hwids usr/bin/
	# Build a legacy ukify compatible stubble
	debian/lace-stubble/usr/bin/pewrap --stub debian/lace-stubble/usr/lib/stubble/lace-stubble.efi --output debian/lace-stubble/usr/lib/stubble/stubble.efi --post-process-for-ukify

## lace 1.3

=== debian/changelog ===
lace (1.3-1) unstable; urgency=medium

  * Initial packaging of Lace as a separate project.
  * Closes: #840726

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Fri, 14 Oct 2016 17:25:33 +0900

## lace 1.3.1

=== debian/changelog ===
lace (1.3.1-1) unstable; urgency=medium

  * New upstream release
  * Closes: #854967

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Mon, 13 Feb 2017 12:09:42 +0000

=== debian/control ===
Source: lace
Section: interpreters
Priority: optional
Maintainer: Daniel Silverstone <dsilvers@digital-scurf.org>
Build-Depends: debhelper (>= 9.20120909~), dh-lua, lua-ldoc, lua-discount
Standards-Version: 3.9.8
Homepage: https://www.gitano.org.uk/lace/

Package: lua-lace
Architecture: all
Depends: ${misc:Depends}
Provides: ${lua:Provides}
XB-Lua-Versions: ${lua:Versions}
Multi-Arch: foreign
Description: Lua Access Control Engine
 Lace is an access control engine written in Lua which implements a squid-like
 ACL system for Lua programs to use in controlling access to resources.
 .
 Lace provides a parser of rulesets and an engine to execute the parsed
 rulesets.  It relies on the calling application to provide access
 control types and then Lace runs the boolean logic and returns an
 allow/deny result along with the location of the decision and any
 description provided by it.

Package: lua-lace-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Documentation for lua-lace
 Lace is an access control engine written in Lua which implements a squid-like
 ACL system for Lua programs to use in controlling access to resources.
 .
 Lace provides a parser of rulesets and an engine to execute the parsed
 rulesets.  It relies on the calling application to provide access
 control types and then Lace runs the boolean logic and returns an
 allow/deny result along with the location of the decision and any
 description provided by it.
 .
 This package contains the documentation on how to use the Lace library.

=== debian/watch ===
version=3
https://git.gitano.org.uk/lace.git /lace\.git/snapshot/lace-(.+)\.tar.bz2

## lace 1.4

=== debian/changelog ===
lace (1.4-1) unstable; urgency=medium

  * New upstream release

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Wed, 02 Aug 2017 18:00:43 -0400

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=lua --with lua

override_dh_auto_build:
	dh_auto_build
	ldoc --date $(SOURCE_DATE_EPOCH) .

override_dh_auto_clean:
	dh_auto_clean
	$(RM) -r html
